package task_cache

import (
	"dcl_dispatch_server/src/package/domain/project"
	"encoding/json"
	"errors"
	"fmt"
)

type TaskCache struct {
	UserId             string       `json:"userId"`
	UserParallelism    int64        `json:"userParallelism"`
	AlgorithmObjectKey string       `json:"algorithmObjectKey"`
	EquipmentType      string       `json:"equipmentType"`
	Env                string       `json:"env"`
	Task               project.Task `json:"task"`
}

func JsonToTaskCache(jsonData string) (TaskCache, error) {
	// 创建一个 Person 类型的变量
	var taskCache TaskCache

	// 使用 json.Unmarshal 解析 JSON 字符串到结构体
	err := json.Unmarshal([]byte(jsonData), &taskCache)
	if err != nil {
		return TaskCache{}, errors.New("对象json " + jsonData + " 转对象失败错误信息为: " + fmt.Sprintf("%v", err))
	}
	return taskCache, nil
}

func TaskCacheToJson(taskCache TaskCache) (string, error) {
	jsonData, err := json.MarshalIndent(taskCache, "", "    ")
	if err != nil {
		return "", err
	}
	return string(jsonData), nil
}
